tree grammar calc5Tree;

options {
    tokenVocab=calc5;
    ASTLabelType=CommonTree;
}

@header {
import java.lang.Double;
import java.lang.Math;
}

calc
    : (expr {System.out.println($expr.value);})+
    ;

expr returns [double value]
    : ^(PLUS e1=expr  {$value = $e1.value;} (e2=expr {$value += $e2.value;})?)
    | ^(MINUS e1=expr {$value = -$e1.value;} (e2=expr {$value = -$value - $e2.value;})?)
    | ^(MULT e1=expr e2=expr)   {$value = $e1.value * $e2.value;}
    | ^(DIV e1=expr e2=expr)    {$value = $e1.value / $e2.value;}
    | ^(POW e1=expr e2=expr)   {$value = Math.pow($e1.value, $e2.value);}
    | DOUBLE                    {$value = Double.parseDouble($DOUBLE.text);}
    | PI                        {$value = Math.PI;}
    | E                         {$value = Math.E;}
    ;
